namespace org.accordproject.finance.bond;
using org.accordproject.organization;
using org.accordproject.time;
using org.accordproject.money;
using AccordProject.Concerto;
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum CouponType {
      FIXED,
      FLOATING,
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.finance.bond", Version = "0.3.0", Name = "PaymentFrequency")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class PaymentFrequency : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.finance.bond@0.3.0.PaymentFrequency";
   public int periodMultiplier { get; set; }
   public Duration period { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.finance.bond", Version = "0.3.0", Name = "Bond")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Bond : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.finance.bond@0.3.0.Bond";
   public string[] instrumentId { get; set; }
   public string description { get; set; }
   public CurrencyCode? currency { get; set; }
   public string[] exchangeId { get; set; }
   public string clearanceSystem { get; set; }
   public string definition { get; set; }
   public string seniority { get; set; }
   public CouponType? couponType { get; set; }
   public float? couponRate { get; set; }
   public System.DateTime maturity { get; set; }
   public float parValue { get; set; }
   public float faceAmount { get; set; }
   public PaymentFrequency paymentFrequency { get; set; }
   public string dayCountFraction { get; set; }
   public Organization issuer { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.finance.bond", Version = "0.3.0", Name = "BondAsset")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class BondAsset : Asset {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.finance.bond@0.3.0.BondAsset";
   [AccordProject.Concerto.Identifier()]
   public string ISINCode { get; set; }
   public Bond bond { get; set; }
}
